<?php

namespace Litecms\Contentdatum\Http\Controllers;

use App\Http\Controllers\PublicController as BaseController;
use Litecms\Contentdatum\Interfaces\ContentdataRepositoryInterface;

class ContentdataPublicController extends BaseController
{
    // use ContentdataWorkflow;

    /**
     * Constructor.
     *
     * @param type \Litecms\Contentdata\Interfaces\ContentdataRepositoryInterface $contentdata
     *
     * @return type
     */
    public function __construct(ContentdataRepositoryInterface $contentdata)
    {
        $this->repository = $contentdata;
        parent::__construct();
    }

    /**
     * Show contentdata's list.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function index()
    {
        $contentdatas = $this->repository
        ->pushCriteria(app('Litepie\Repository\Criteria\RequestCriteria'))
        ->scopeQuery(function($query){
            return $query->orderBy('id','DESC');
        })->paginate();


        return $this->response->title(trans('$contentdatum::$contentdata.names'))
            ->view('$contentdatum::public.contentdata.index')
            ->data(compact('$contentdatas'))
            ->output();
    }

    /**
     * Show contentdata's list based on a type.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function list($type = null)
    {
        $contentdatas = $this->repository
        ->pushCriteria(app('Litepie\Repository\Criteria\RequestCriteria'))
        ->scopeQuery(function($query){
            return $query->orderBy('id','DESC');
        })->paginate();


        return $this->response->title(trans('$contentdatum::$contentdata.names'))
            ->view('$contentdatum::public.contentdata.index')
            ->data(compact('$contentdatas'))
            ->output();
    }

    /**
     * Show contentdata.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function show($slug)
    {
        $contentdata = $this->repository->scopeQuery(function($query) use ($slug) {
            return $query->orderBy('id','DESC')
                         ->where('slug', $slug);
        })->first(['*']);

        return $this->response->title($$contentdata->name . trans('$contentdatum::$contentdata.name'))
            ->view('$contentdatum::public.contentdata.show')
            ->data(compact('$contentdata'))
            ->output();
    }

}
