<?php

namespace Litecms\Contentdatum\Repositories\Presenter;

use League\Fractal\TransformerAbstract;
use Hashids;

class ContentdataTransformer extends TransformerAbstract
{
    public function transform(\Litecms\Contentdatum\Models\Contentdata $contentdata)
    {
        return [
            'id'                => $contentdata->getRouteKey(),
            'key'               => [
                'public'    => $contentdata->getPublicKey(),
                'route'     => $contentdata->getRouteKey(),
            ], 
            'name'              => $contentdata->name,
            'content'           => $contentdata->content,
            'slug'              => $contentdata->slug,
            'url'               => [
                'public'    => trans_url('contentdatum/'.$contentdata->getPublicKey()),
                'user'      => guard_url('contentdatum/contentdata/'.$contentdata->getRouteKey()),
            ], 
            'status'            => trans('app.'.$contentdata->status),
            'created_at'        => format_date($contentdata->created_at),
            'updated_at'        => format_date($contentdata->updated_at),
        ];
    }
}